package com.engine.attendance.attendanceanalysis.wrapper;

import com.engine.attendance.attendanceanalysis.service.BeLateService;
import com.engine.attendance.attendanceanalysis.service.ForgetClockInService;
import com.engine.attendance.attendanceanalysis.service.UtilService;
import com.engine.attendance.attendanceanalysis.service.impl.BeLateServiceImpl;
import com.engine.attendance.attendanceanalysis.service.impl.ForgetClockInServiceImpl;
import com.engine.attendance.attendanceanalysis.service.impl.UtilServiceImpl;
import com.engine.attendance.attendanceplan.service.AttendancePlanService;
import com.engine.attendance.attendanceplan.service.impl.AttendancePlanServiceImpl;
import com.engine.attendance.component.persongroup.service.SchedulingResultsService;
import com.engine.attendance.component.persongroup.service.impl.SchedulingResultsServiceImpl;
import com.engine.attendance.enums.WorkForTimeEnum;
import com.engine.common.util.DateUtil;
import com.engine.common.util.DbTools;
import com.engine.common.util.ServiceUtil;
import com.engine.core.impl.Service;
import com.google.common.collect.Maps;
import weaver.general.Util;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 考勤分析主题逻辑
 */
public class AttendanceAnalysisWrapper extends Service {

    private AttendancePlanService basicsetService = ServiceUtil.getService(AttendancePlanServiceImpl.class);
    private BeLateService beLateService = ServiceUtil.getService(BeLateServiceImpl.class);
    private UtilService utilService = ServiceUtil.getService(UtilServiceImpl.class);
    private ForgetClockInService forgetClockInService = ServiceUtil.getService(ForgetClockInServiceImpl.class);

    public void attendanceAnalysis(String userId, List<Map<String,Object>> dataList){
        String beforeThreeDayDate = DateUtil.getCurrentDateMinusDay(3);
        String beforeTwoDayDate = DateUtil.getCurrentDateMinusDay(2);
        String beforeOneDayDate = DateUtil.getCurrentDateMinusDay(1);
        Map<String, List<Map<String,Object>>> collect = dataList.stream().collect(Collectors.groupingBy(e -> Util.null2String(e.get("signdate"))));

        /**获得人员考勤项目*/
        Map<String,Object> paramMap = Maps.newHashMap();
        paramMap.put("startDate","");
        paramMap.put("endDate","");
        paramMap.put("resourceId","85");
        paramMap.put("modeId","204");
        Map<String,Object> dataMap = basicsetService.getAttendanceItemsByPerson(paramMap);
        List<Map<String,Object>> attendanceItems = (List<Map<String,Object>>)dataMap.get("data");

        /** 获取人员班次*/
        Map<String,Object> classesParamMap = Maps.newHashMap();
        classesParamMap.put("tableName","uf_pbjg");
        classesParamMap.put("startDate",beforeThreeDayDate);
        classesParamMap.put("endDate",beforeOneDayDate);
        classesParamMap.put("pblx","0");
        classesParamMap.put("pbdx",userId);
        classesParamMap.put("current","1");
        classesParamMap.put("pageSize",1);
        classesParamMap.put("recurrence",1);
        Map<String,List<Map<String,Object>>> schedulingResultsMap = utilService.getSchedulingInFormation(paramMap);

        /**获得人员加班计划*/
        String sql = "select jbry,ksrq,kssj,jsrq,jssj,jbsc, from uf_jcl_kq_jbjh_dt1 where jbry=? and ksrq>=? and ksrq<=? and jbcx=1";
        Map<String,List<Map<String,Object>>> overtimePlanMap = DbTools.getSqlToList(sql,userId,beforeOneDayDate,beforeThreeDayDate).stream().collect(Collectors.groupingBy(e -> Util.null2String(e.get("ksrq"))));
        Map<String,Object> forgetClockInParam = Maps.newHashMap();
        forgetClockInParam.put("classInfo",schedulingResultsMap.get(beforeOneDayDate));
        forgetClockInParam.put("userId",schedulingResultsMap.get(beforeOneDayDate));


        /**计算获取前一天和第二天打卡数据*/
        if (collect.size() == 0){
            //没有打卡数据，漏打卡
            forgetClockInParam.put("date",beforeOneDayDate);

            forgetClockInService.ForgetClockInAllDays(forgetClockInParam);
        }else if (collect.size() == 1){
            //有1天有打卡数据
            if (collect.get(beforeOneDayDate) != null){
                //前一天有打卡记录


            }else {
                //否则前一天记为漏打卡


            }
        }else if (collect.size() == 2){
            //有2天有打卡数据

            if (collect.get(beforeOneDayDate) == null){
                //前一天漏打卡


            }else if(collect.get(beforeOneDayDate) != null && collect.get(beforeTwoDayDate) == null){
                //前一天有打卡记录，第二天没有打卡记录


            }else if (collect.get(beforeTwoDayDate) != null && collect.get(beforeOneDayDate) != null){
                //前一天有打卡，第二天有打卡记录


            }


        }else if (collect.size() == 3){
            //连续3天打卡


        }
    }



}
